stages:
 - build
 - test
 - review
 - deploy

default:
 image: openjdk:11
 cache:
   key:
     files:
       - pom.xml
     prefix: ${CI_JOB_NAME}
   paths:
     - .cache

build:
 stage: build
 script:
   - ./mvnw package
checkstyle:
 stage: test
 script:
   - ./mvnw checkstyle:check
 needs: []
unit-test:
 stage: test
 script:
   - ./mvnw test
 needs: []
review:
 image: docker:latest
 stage: test
 script:
   - echo "deploy our review app"
 environment:
   name: review/$CI_COMMIT_REF_NAME
   url: https://gitlab.com/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/-/tree/$CI_COMMIT_REF_NAME
   auto_stop_in: 2 days
 needs:
   - build
accept-review:
 image: docker:latest
 stage: review
 script:
   - echo "the app is ready, shutdown our review app"
 environment:
   name: review/$CI_COMMIT_REF_NAME
   url: https://gitlab.com/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/-/tree/$CI_COMMIT_REF_NAME
   action: stop
 when: manual
 needs:
   - review
docker-build:
 needs:
   - accept-review
 image: docker:latest
 stage: deploy
 services:
   - docker:dind
 before_script:
   - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
 script:
   - docker build --pull -t "$CI_REGISTRY_IMAGE" .
   - docker push "$CI_REGISTRY_IMAGE"
 when: manual
